<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfInterfaceViaRouteResult_V3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfInterfaceViaRouteResult_V3 extends AbstractStructArrayBase
{
    /**
     * The InterfaceViaRouteResult_V3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\InterfaceViaRouteResult_V3[]
     */
    public $InterfaceViaRouteResult_V3;
    /**
     * Constructor method for ArrayOfInterfaceViaRouteResult_V3
     * @uses ArrayOfInterfaceViaRouteResult_V3::setInterfaceViaRouteResult_V3()
     * @param \StructType\InterfaceViaRouteResult_V3[] $interfaceViaRouteResult_V3
     */
    public function __construct(array $interfaceViaRouteResult_V3 = array())
    {
        $this
            ->setInterfaceViaRouteResult_V3($interfaceViaRouteResult_V3);
    }
    /**
     * Get InterfaceViaRouteResult_V3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\InterfaceViaRouteResult_V3[]|null
     */
    public function getInterfaceViaRouteResult_V3()
    {
        return isset($this->InterfaceViaRouteResult_V3) ? $this->InterfaceViaRouteResult_V3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setInterfaceViaRouteResult_V3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setInterfaceViaRouteResult_V3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateInterfaceViaRouteResult_V3ForArrayConstraintsFromSetInterfaceViaRouteResult_V3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfInterfaceViaRouteResult_V3InterfaceViaRouteResult_V3Item) {
            // validation for constraint: itemType
            if (!$arrayOfInterfaceViaRouteResult_V3InterfaceViaRouteResult_V3Item instanceof \StructType\InterfaceViaRouteResult_V3) {
                $invalidValues[] = is_object($arrayOfInterfaceViaRouteResult_V3InterfaceViaRouteResult_V3Item) ? get_class($arrayOfInterfaceViaRouteResult_V3InterfaceViaRouteResult_V3Item) : sprintf('%s(%s)', gettype($arrayOfInterfaceViaRouteResult_V3InterfaceViaRouteResult_V3Item), var_export($arrayOfInterfaceViaRouteResult_V3InterfaceViaRouteResult_V3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The InterfaceViaRouteResult_V3 property can only contain items of type \StructType\InterfaceViaRouteResult_V3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set InterfaceViaRouteResult_V3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\InterfaceViaRouteResult_V3[] $interfaceViaRouteResult_V3
     * @return \ArrayType\ArrayOfInterfaceViaRouteResult_V3
     */
    public function setInterfaceViaRouteResult_V3(array $interfaceViaRouteResult_V3 = array())
    {
        // validation for constraint: array
        if ('' !== ($interfaceViaRouteResult_V3ArrayErrorMessage = self::validateInterfaceViaRouteResult_V3ForArrayConstraintsFromSetInterfaceViaRouteResult_V3($interfaceViaRouteResult_V3))) {
            throw new \InvalidArgumentException($interfaceViaRouteResult_V3ArrayErrorMessage, __LINE__);
        }
        if (is_null($interfaceViaRouteResult_V3) || (is_array($interfaceViaRouteResult_V3) && empty($interfaceViaRouteResult_V3))) {
            unset($this->InterfaceViaRouteResult_V3);
        } else {
            $this->InterfaceViaRouteResult_V3 = $interfaceViaRouteResult_V3;
        }
        return $this;
    }
    /**
     * Add item to InterfaceViaRouteResult_V3 value
     * @throws \InvalidArgumentException
     * @param \StructType\InterfaceViaRouteResult_V3 $item
     * @return \ArrayType\ArrayOfInterfaceViaRouteResult_V3
     */
    public function addToInterfaceViaRouteResult_V3(\StructType\InterfaceViaRouteResult_V3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\InterfaceViaRouteResult_V3) {
            throw new \InvalidArgumentException(sprintf('The InterfaceViaRouteResult_V3 property can only contain items of type \StructType\InterfaceViaRouteResult_V3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->InterfaceViaRouteResult_V3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\InterfaceViaRouteResult_V3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\InterfaceViaRouteResult_V3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\InterfaceViaRouteResult_V3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\InterfaceViaRouteResult_V3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\InterfaceViaRouteResult_V3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InterfaceViaRouteResult_V3
     */
    public function getAttributeName()
    {
        return 'InterfaceViaRouteResult_V3';
    }
}
